#!/usr/bin/python
# -*- coding: utf-8 -*-

from distutils.core import setup
import os

version_id = "0.7.2"

if os.name == 'posix' :
	setup(
		name				= "glda",
		version				= version_id,
		description			= "Glda - utilitaire de création de liste d'achat.",
		long_description	= """ Glda (Gtk Liste D'Achat) permet de créer sa liste d'achat avant d'aller au supermarché. """,
		author				= "TuxGasy",
		author_email		= "tuxgasy@tuxfamily.org",
		url					= "http://glda.tuxfamily.org",
		license				= "GNU GPL version 3",
		requires			= ['gtk'],
		platforms			= ['any'],
		packages			= ['gldalib'],
		scripts				= ['glda'],
		data_files			= [('share/glda', ['misc/glda.glade']),
							   ('share/pixmaps', ['misc/glda.png']),
							   ('share/applications', ['misc/glda.desktop']),
							   ('share/doc/glda', ['README.txt']),
							   ('share/doc/glda', ['doc/copyright']),
							   ('share/doc/glda', ['doc/changelog'])]
	)

elif os.name == 'nt' :
	import py2exe
	
	opts = {
        'py2exe': {
            'packages': ['encodings', 'gtk', 'gldalib'],
            'includes': ['locale', 'sqlite3', 'cairo', 'pangocairo', 'pango', 'atk', 'gobject', 'gio', 'os'],
            'excludes': ["ltihooks", "gdk", "pywin", "pywin.debugger", "pywin.debugger.dbgcon",
                "pywin.dialogs", "pywin.dialogs.list",
                "Tkconstants","Tkinter","tcl",
                "doctest","macpath","pdb",
                "cookielib","ftplib","pickle",
                "calendar","win32wnet","unicodedata",
                "getopt"],
            'dll_excludes': ["libglade-2.0-0.dll", "w9xpopen.exe"],
            'optimize': '2'
            }
        }
	
	setup(
		name				= "glda",
		version				= version_id,
		description			= "Glda - utilitaire de création de liste d'achat.",
		long_description	= """ Glda (Gtk Liste D'Achat) permet de créer sa liste d'achat avant d'aller au supermarché. """,
		author				= "TuxGasy",
		author_email		= "tuxgasy@tuxfamily.org",
		url					= "http://glda.tuxfamily.org",
		license				= "GNU GPL version 3",
		requires			= ['gtk'],
		windows				= [
								{'script' : 'glda',
								 'icon_resources' : [(1 ,'misc/glda.ico')]} 
							],
		options				= opts,
		data_files			= [
								('glade', ['misc/glda.glade']),
								('pixmaps', ['misc/glda.png']),
								('doc', ['README.txt', 'doc/copyright', 'doc/changelog'])
							],
		zipfile				= None
	)

	iss_file = 'glda.iss'
	print 'Writing iss file : '+iss_file
	ofi = open(iss_file, "w")
	print >> ofi, "; Script generated by py2exe."
	print >> ofi, "; Will be overwritten the next time py2exe is run!"
	
	print >> ofi, """
#define MyAppName "Glda (Gestion Liste D'Achat)"
#define MyAppVersion "%s"
#define MyAppPublisher "TuxGasy"
#define MyAppURL "http://glda.tuxfamily.org"
#define MyAppExeName "glda.exe"
	"""%version_id
	
	print >> ofi, r"[Setup]"
	print >> ofi, """
AppName={#MyAppName}
AppVersion={#MyAppVersion}
AppPublisher={#MyAppPublisher}
AppPublisherURL={#MyAppURL}
DefaultDirName={pf}\glda
DefaultGroupName={#MyAppName}
LicenseFile=doc\copyright
OutputBaseFilename=glda_{#MyAppVersion}
SetupIconFile=misc\glda.ico
Compression=lzma
SolidCompression=yes
	"""
	
	print >> ofi, r"[Languages]"
	print >> ofi, """
Name: "french"; MessagesFile: "compiler:Languages\French.isl"
	"""
	
	print >> ofi, r"[Tasks]"
	print >> ofi, """
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked
	"""
	
	print >> ofi, r"[Files]"
	print >> ofi, """
Source: "dist\glda.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "dist\*"; DestDir: "{app}"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "C:\GTK\etc\gtk-2.0\*"; DestDir: "{app}\etc\gtk-2.0\"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "C:\GTK\lib\*"; DestDir: "{app}\lib\"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "C:\GTK\share\locale\*"; DestDir: "{app}\share\locale\"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "C:\GTK\share\\themes\*"; DestDir: "{app}\share\\themes\"; Flags: ignoreversion recursesubdirs createallsubdirs
	"""
	
	print >> ofi, r"[Icons]"
	print >> ofi, """
Name: "{group}\{#MyAppName}"; Filename: "{app}\{#MyAppExeName}"
Name: "{commondesktop}\{#MyAppName}"; Filename: "{app}\{#MyAppExeName}"; Tasks: desktopicon
	"""
	
	print >> ofi, r"[Run]"
	print >> ofi, """
Filename: "{app}\{#MyAppExeName}"; Description: "{cm:LaunchProgram,{#StringChange(MyAppName, "&", "&&")}}"; Flags: nowait postinstall skipifsilent
	"""
	
